import { ComputeOptions, computeValue } from "../../core";
import { isNil } from "../../util";
/**
 * Returns an array of all values for the selected field among for each document in that group.
 *
 * @param {Array} collection The input array
 * @param {Object} expr The right-hand side expression value of the operator
 * @param {Options} options The options to use for this operation
 * @returns {Array|*}
 */
export const $push = (collection, expr, options) => {
    if (isNil(expr))
        return collection;
    const copts = ComputeOptions.init(options);
    return collection.map(obj => computeValue(obj, expr, null, copts.update(obj)));
};
