/**
 * String Expression Operators: https://docs.mongodb.com/manual/reference/operator/aggregation/#string-expression-operators
 */
import { computeValue } from "../../../core";
/**
 * Returns the number of UTF-8 encoded bytes in the specified string.
 *
 * @param  {Object} obj
 * @param  {String} expr
 * @return {Number}
 */
export const $strLenBytes = (obj, expr, options) => {
    return ~-encodeURI(computeValue(obj, expr, null, options)).split(/%..|./).length;
};
